/**
 * 
 * 
 * 
 */
package gov.va.nvap.server.endpoint.dataquality;


import gov.va.nvap.service.audit.AuditException;
import java.net.MalformedURLException;
import java.io.InputStream;
import java.nio.charset.StandardCharsets;

import gov.va.nvap.service.dataquality.DqTransmissionLogManager;
import gov.va.nvap.service.dataquality.DqTransmissionLogQueryRequest;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;

import org.apache.commons.io.IOUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;




/**
 *
 * 
 */
// TODO: Uncomment these two lines to use mock, and comment-out these lines in the real class
//@Stateless(name = "DqTransmissionLogManager", mappedName = "DqTransmissionLogManager")
//@javax.ejb.Remote(DqTransmissionLogManager.class)
public class MockDqTransmissionLogServiceEndpoint implements DqTransmissionLogManager {
    
    static private final Log LOG = LogFactory.getLog(MockDqTransmissionLogServiceEndpoint.class);


    public MockDqTransmissionLogServiceEndpoint() {
        super();
    }
    
    
    @Override
    public String getDqTransmissionLogData(DqTransmissionLogQueryRequest logQueryRequest) throws AuditException {
        
       final String mockFilename = "sampleDQTransmissionLogServiceResponseJsonString.json";            
       InputStream inputStream = getClass().getClassLoader().getResourceAsStream(mockFilename);
        try {
            // TODO: file is in nvap-server/src/test/resources/gov/.../dataquality, 
            // needs to be placed in src/test/resources, and needs to be allowed in by Maven filtering include for .json
            
            String response = IOUtils.toString(inputStream, StandardCharsets.UTF_8.name());
            
            LOG.info(" mock dq response data is: "+response);
            return response;
     
        } catch (MalformedURLException e) {
            e.printStackTrace(System.out);
            LOG.error(e);  
            throw new AuditException("DqTransmissionLogServiceEndpoint GET request threw Exception: ",e);
        } catch (IOException e) {
            e.printStackTrace(System.out);
            LOG.error(e);  
            throw new AuditException("DqTransmissionLogServiceEndpoint GET request threw Exception: ",e);          
        }
        finally
        {
            IOUtils.closeQuietly(inputStream);
        }
    }
    
}
