<%-- 
    Document   : timePicker
    Created on : Dec 14, 2017, 8:15:34 PM
    Author     : Johann P. Sonnenberg
--%>

<%@tag description="put the tag description here" pageEncoding="UTF-8"%>

<%@attribute name="prefixId" required="true" description="prefix to use for all the field ids. i.e. using bro will produce fields with ids of broHour, broMinute, and broMedian." %>
<%@attribute name="prefixName" required="true" description="prefix to use for all the field names. i.e. using bro will produce fields with names of broHour, broMinute, and broMedian." %>
<%@attribute name="labelPrefix" required="true" description="text to put before the aria-label i.e. using Start will produce an aria-label for the hour as Start Hour." %>
<%@attribute name="hourSelected" required="false" description="default selection for the hour dropdown" %>
<%@attribute name="minuteSelected" required="false" description="default selection for the minute dropdown" %>
<%@attribute name="meridianSelected" required="false" description="default selection for the meridian dropdown" %>


<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>

<%-- tag content goes here --%>
<select id="${prefixId}Hour" name="${prefixName}Hour" class="form-control" aria-label="${labelPrefix} Hour">
    <c:forEach var = "i" begin = "1" end = "12">
        <option value="<fmt:formatNumber minIntegerDigits="2" value="${i}" />" <c:if test="${hourSelected == i}">selected="selected"</c:if>><fmt:formatNumber minIntegerDigits="2" value="${i}" /></option>
    </c:forEach>
</select>
<span class="bold vap-size-12">:</span>
<select id="${prefixId}Minute" name="${prefixName}Minute" class="form-control" aria-label="${labelPrefix} Minute">
    <c:forEach var = "i" begin = "0" end = "55" step="5">
        <option value="<fmt:formatNumber minIntegerDigits="2" value="${i}" />" <c:if test="${minuteSelected == i}">selected="selected"</c:if>><fmt:formatNumber minIntegerDigits="2" value="${i}" /></option>
    </c:forEach>
</select>
<span class="pad-right-10"></span>
<select id="${prefixId}Meridian" name="${prefixName}Meridian" class="form-control" aria-label="${labelPrefix} Meridian">
    <option value="AM" <c:if test="${meridianSelected == 'AM'}">selected="selected"</c:if>>AM</option>
    <option value="PM" <c:if test="${meridianSelected == 'PM'}">selected="selected"</c:if>>PM</option>
</select>