<%-- 
    Document   : viewFacility
    Created on : Jan 9, 2017, 12:22:21 PM
    Author     : Raul Alfaro
--%>

<%@page import="gov.va.nvap.web.user.User"%>
<%@taglib tagdir="/WEB-INF/tags/formatting" prefix="f" %>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@taglib tagdir="/WEB-INF/tags/cpp" prefix="cpp"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn"%>
<%@page contentType="text/html" pageEncoding="UTF-8"%>


<%
  User user = (User) session.getAttribute("user");
  String sortColumn = user.getUserPreference("reportFacilitySortColumn");
  String sortDirection = user.getUserPreference("reportFacilitySortDirection");
  String sortFullValue = sortColumn.length() > 0 ? "[[" + sortColumn + ", '" + sortDirection + "']]" : "[[1, 'asc']]";
  pageContext.setAttribute("sortFullValue", sortFullValue);
%>

<f:mainTemplate headerText="Facilities">
    <script type="text/javascript">
        $(document).ready(function () {

            VAP.common.constructUrl = function (methodName) {
                var url = 'ViewFacility.do_sec?' + methodName + '=true';

                if (methodName === 'exportToExcel') {
                    url = url + '&order[0][column]=' + $('#reportTable').dataTable().fnSettings().aaSorting[0][0] +
                        '&order[0][dir]=' + $('#reportTable').dataTable().fnSettings().aaSorting[0][1];
                }

                return url;
            };
            
            VAP.common.setProcessingForDataTable('reportTable', 'divReportPanel'); 

            VAP.common.reportTable = $('#reportTable').DataTable({
                destroy: true,
                ajax: {
                    url: VAP.common.constructUrl("doSearch"),
                    dataSrc: function (json) {
                        $('.dataTables_empty').remove();
                        return json.data;
                    },
                    error: function (o) {
                        VAP.common.handleErrorsInDataTable('reportTable', o, 9, 'divReportPanel');
                    }
                },
                dom: "<'row'<'col-sm-12'l>>" +
                        "<'row'<'col-sm-6'i><'col-sm-6'p>>" +
                        "<'row'<'col-sm-12't<'pad-bottom-20'>r>>" +
                        "<'row'<'col-sm-5'i><'col-sm-7'p>>",
                serverSide: true,
                processing: true,
                searching: false,
                lengthMenu: [10, 25, 50, 100, 250, 500],
                pageLength: 25,
                columnDefs: [
                    {
                        targets: 1,
                        data: null,
                        render: function (data, type, full, meta) {
                           if(data[11] !== 'False'){
                                return data[1];
                            } else {
                                return data[1] + " [Inactive]";
                            }
                        }
                    },
                    {
                        targets: 6,
                        data: null,
                        render: function (data, type, full, meta) {
                            if (data[6] !== '' && data[6] !== null) {
                                return data[6].replace(/(\d{3})(\d{3})(\d{4})/, '($1) $2-$3');
                            } else {
                                return data[6];
                            }
                        }
                    },
                    {
                        targets: 8,
                        data: null,
                        render: function (data, type, full, meta) {
                            if (data[8] !== 'None') {
                                return '<a href="#/" onclick="editStation(parseStationNumber(\'' + data[8] + '\'));">' + data[8] + '</a>';
                            } else {
                                if(data[11] !== 'False'){
                                  return data[8];  
                                } else {
                                    return "";
                                }
                            }
                        }
                    },
                    {
                        targets: 9,
                        data: null,
                        render: function (data, type, full, meta) {
                            if (data[9] !== 'None') {
                                var children = data[9].split('|');
                                var endResult = "";

                                $.each(children, function (index, value) {
                                    endResult = endResult + '<a href="#/" onclick="editStation(parseStationNumber(\'' + value + '\'));">' + value + '</a><br>';
                                });
                                return endResult;
                            } else {
                                if(data[11] !== 'False'){
                                  return data[9];  
                                } else {
                                    return "";
                                }
                            }
                        }
                    },
                    {
                        targets: -1,
                        data: null,
                        render: function (data, type, full, meta) {
                            
                            if(data[11] !== 'False'){
                                return '<a class="btn btn-xs btn-primary" alt="Edit Facility" href="EditFacility.do_sec?stationNumber=' + data[0] + '">Edit</a>';
                            } else {
                                return '<a class="btn btn-xs btn-primary reactivateStation" alt="Reactivate Facility" data-toggle="confirmReactivateModal" data-id=' + data[0] + ' data-name=\"' + data[1] + '\">Reactivate</a>';
                            }
                        }
                    },
                    {className: 'vap-pre-wrap', targets: 9},
                    {className: 'text-center vertical-align-center', targets: 11},
                    {orderable: false, targets: [ 8, 9, 10, 11]}
                ],
                order: <c:out value="${sortFullValue}" escapeXml="false" />
            });

            // DataTable overrides
            VAP.common.reportTable.on('draw', function () {
                VAP.common.addAriaToDataTable('reportTable', VAP.common.reportTable);
                VAP.common.addSrollingToDataTable('reportTable');
            });
            
            $('#confirmReactivationModalReactivation').on('click', function(){
                window.location.href = 'EditFacility.do_sec?reactivateFacility=true&stationNumber=' + $("#reactivateStationNumber").val();
            });
            
            $(document).on("click", ".reactivateStation", function () {
                var reactivateStationNumber = $(this).data('id');
                var reactivateStationName = $(this).data('name');
                $("#reactivateStationNumber").val( reactivateStationNumber );
                $("#reactivateStationName").text(reactivateStationName);
                $("#confirmReactivateModal").modal('show');
            });
        });

        parseStationNumber = function(fullName) {
            var stationNumberRegex = /(\d{3}(\w{1,2})?)(?=\)$)/g;

            return stationNumberRegex.exec(fullName)[0];
        };

        editStation = function(stationNumber) {
            location.href = 'EditFacility.do_sec?stationNumber=' + stationNumber;
        };
    </script>

    <cpp:errors/>
    <div class="row">
        <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12">
            <c:if test="${not empty facilityMessage}">
                <div class="alert alert-success alert-dismissible pad-bottom-10 pad-top-10 pad-left-10" role="alert">
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                    <c:out value="${facilityMessage}" />
                </div>
            </c:if>
        </div>
    </div>
    <div><div aria-live="assertive" role="alert" id="reportTable_info"></div></div>
    <div class="row">
        <div id="divReportContent" class="col-xs-12 col-sm-12 col-md-12 col-lg-12">
            <input type="hidden" id="reactivateStationNumber" value=""/>
            <div class="panel panel-default" id="divReportPanel">
                <div class="panel-heading">
                    <div class="panel-title">
                        <div class="text-right">
                            <a href="EditFacility.do_sec?stationNumber=" title="Add Facility" class="pad-right-10"><i class="fa fa-plus" aria-hidden="true"></i> Add Facility</a>
                            <a href="#" class="directDownload" data-method="exportToExcel" title="Export to Excel"><i class="fa fa-download" aria-hidden="true"></i> Export to Excel</a>
                        </div>
                    </div>
                </div>    
                <div class="panel-body" id="facilityListPanel">
                    <table id="reportTable" class="table table-striped " width="100%" cellspacing="0" role="presentation">
                        <thead>
                            <tr role="row">
                                <th role="columnheader" class="text-center"><span id="stationNumberHeader" data-tooltip="<c:out value="${descriptors['viewFacilityStationNumber']}" />">Station Number</span></th>
                                <th role="columnheader" class="text-center"><span id="nameHeader" data-tooltip="<c:out value="${descriptors['viewFacilityName']}" />">Name</span></th>
                                <th role="columnheader" class="text-center"><span id="addressHeader" data-tooltip="<c:out value="${descriptors['viewFacilityAddress']}" />">Address</span></th>
                                <th role="columnheader" class="text-center"><span id="cityHeader" data-tooltip="<c:out value="${descriptors['viewFacilityCity']}" />">City</span></th>
                                <th role="columnheader" class="text-center"><span id="stateHeader" data-tooltip="<c:out value="${descriptors['viewFacilityState']}" />">State</span></th>
                                <th role="columnheader" class="text-center"><span id="zipCodeHeader" data-tooltip="<c:out value="${descriptors['viewFacilityZipCode']}" />">Zip Code</span></th>
                                <th role="columnheader" class="text-center"><span id="phoneNumberHeader" data-tooltip="<c:out value="${descriptors['viewFacilityPhoneNumber']}" />">Phone Number</span></th>
                                <th role="columnheader" class="text-center"><span id="visnHeader" data-tooltip="<c:out value="${descriptors['viewFacilityVISN']}" />">VISN</span></th>
                                <th role="columnheader" class="text-center"><span id="parentHeader" data-tooltip="<c:out value="${descriptors['viewFacilityParent']}" />">Parent</span></th>
                                <th role="columnheader" class="text-center"><span id="childrenHeader" data-tooltip="<c:out value="${descriptors['viewFacilityChildren']}" />">Children</span></th>
                                <th role="columnheader" class="text-center"><span id="allowedHeader" data-tooltip="<c:out value="${descriptors['viewFacilityAllowed']}" />">Allowed</span></th>
                                <th role="columnheader" class="text-center"><span id="actionHeader" data-tooltip="<c:out value="${descriptors['viewFacilityAction']}" />" data-tooltip-position="left">Action</span></th>
                            </tr>
                        </thead>
                    </table>
                </div>
            </div>
        </div>
    </div>                              
    <div class="modal fade" id="confirmReactivateModal" tabindex="-1" role="dialog" data-backdrop="static" aria-labelledby="confirmReactivateModalLabel">
        <div class="vertical-alignment-helper">
            <div class="modal-dialog vertical-align-center" role="document">
                <div class="modal-content">
                    <div class="modal-header">
                        <h4 class="modal-title" id="confirmReactivateModalLabel">Confirm Reactivation</h4>
                    </div>
                    <div class="modal-body">
                        <p>
                            Are you sure you want to reactivate <span id="reactivateStationName"></span> facility?
                        </p>
                    </div>
                    <div class="modal-footer">
                        <button type="button" id="confirmReactivationModalcancelReactivation" class="btn btn-default" data-dismiss="modal">Cancel</button>
                        <button type="button" id="confirmReactivationModalReactivation" class="btn btn-primary">Reactivate</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
</f:mainTemplate>
