<%--
    Document   : delayedConsentReport
    Created on : Apr 5, 2016, 2:13:02 PM
    Author     : Irakli Kakushadze
--%>

<%@taglib tagdir="/WEB-INF/tags/formatting" prefix="f" %>
<%@page import="java.util.HashMap"%>
<%@page import="gov.va.nvap.svc.facility.data.Facility"%>
<%@page contentType="text/html" pageEncoding="UTF-8"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn" %>

<%
    HashMap tips = (HashMap) session.getAttribute("descriptors");
    String facilityFilterTooltip = (String) tips.get("authenticatingFacilityField");
    Facility defaultUserFacility = (Facility) session.getAttribute("defaultUserFacility");
    String defaultUserFacilityName = defaultUserFacility == null ? "" : defaultUserFacility.getFacilityName();
    String defaultUserFacilityStation = defaultUserFacility == null ? "" : defaultUserFacility.getFacilityStation();
    pageContext.setAttribute("facilityFilterTooltip", facilityFilterTooltip);
    pageContext.setAttribute("defaultUserFacility", defaultUserFacility);
    pageContext.setAttribute("defaultUserFacilityName", defaultUserFacilityName);
    pageContext.setAttribute("defaultUserFacilityStation", defaultUserFacilityStation);
%> 

<f:mainTemplate headerText="Delayed Consent Detail Report">
    <script language="JavaScript">
        $(document).ready(function () {
            // Check the ALL checkbox for the reasons on initial load
            $('.allableCheckbox[value=ALL]').prop('checked', true);
            
            VAP.common.constructUrl = function (methodName) {
                var reasonsForDelay = [];
                $('.allableCheckbox:checkbox:checked').each(function () {
                    reasonsForDelay.push($(this).val());
                });

                var url = 'DelayedConsentReport.do_sec' +
                        '?' + methodName + '=true' +
                        '&ssn=' + $('#ssn').val() +
                        '&lastName=' + $('#lastName').val() +
                        '&firstName=' + $('#firstName').val() +
                        '&stationNumbers=' + facilitiesDialog.getSelectedStationNumbers() +
                        '&includeUnknownVisn=' + facilitiesDialog.getIncludeUnknownVisn() +
                        '&reasonsForDelay=' + reasonsForDelay.toString() +
                        '&daysSinceDelayed=' + $('#daysSinceDelayed').val() +
                        '&consentType=' + $('#consentType').val() +
                        '&sortBy=' + $('#reportTable').dataTable().fnSettings().aaSorting[0][0] +
                        '&sortOrder=' + $('#reportTable').dataTable().fnSettings().aaSorting[0][1] +
                        '&patientTypes=' + $('#patientTypes').val() +
                        '&enteredBy=' + $('#enteredBy').val();

                if (methodName === 'exportToCsv' || methodName === 'exportToExcel') {
                    url = url + '&totalRows=' + VAP.common.reportTable.page.info().recordsTotal;
                }
                return url;
            };

            // Initial data request.
            VAP.common.setProcessingForDataTable('reportTable', 'divReportPanel');
            
            VAP.common.reportTable = $('#reportTable').DataTable({
                deferLoading: 0,
                destroy: true,
                searching: false,
                processing: true,
                serverSide: true,
                order: [[0, 'desc']],
                columnDefs: [
                    {orderable: false, targets: [7, 10]},
                    {width: '80', targets: 2},
                    {className: 'vap-report-nowrap dt-head-center', targets: 2},
                    {className: "vap-col-min-130 dt-head-center", targets: [0, 9]},
                    {className: "dt-head-center", targets: [1, 3, 4, 5, 6, 7, 8, 10]}
                ],
                ajax: 'DelayedConsentReport.do_sec?doSearch=true',
                dom: "<'row'<'col-sm-12'l>>" +
                        "<'row'<'col-sm-6'i><'col-sm-6'p>>" +
                        "<'row'<'col-sm-12't<'pad-bottom-20'>r>>" +
                        "<'row'<'col-sm-5'i><'col-sm-7'p>>",
                lengthMenu: [10, 25, 50, 100, 250, 500],
                pageLength: 25
            });

            // DataTables overrides
            VAP.common.reportTable.on('draw', function () {
                VAP.common.addAriaToDataTable('reportTable', VAP.common.reportTable);
                VAP.common.addSrollingToDataTable('reportTable');
            });

            $('#searchButton').on('click', function () {
                $('#reportTable .dataTables_empty').html(''); //blank out the empty table message if there is one
                
                // Validate data before submitting to the server.
                $('#errorMessage').hide();
                if (validateSsns($('#ssn'))) {
                    $('#results').show();
                    VAP.common.reportTable.ajax.url(VAP.common.constructUrl('doSearch')).load();
                } else {
                    showSsnError();
                    return false;
                }
            });

            function validateSsns(field) {
                var sansWhiteSpace = field.val().replace(/ /g, '');
                if (sansWhiteSpace !== null) {
                    if (/^\d{9}(,\d{9})*$/.test(sansWhiteSpace) || sansWhiteSpace === '') {
                        field.val(sansWhiteSpace);
                        return true;
                    } else {
                        return false;
                    }
                }
            }

            function showSsnError() {
                $('#errorMessage').html('Please enter valid nine digit SSN numbers only, no hyphens. If entering multiple SSNs, separate them by commas.');
                $('#errorMessage').show();
            }
            
            $('#results').hide();
        });
    </script>
    <%@include file="patientLinkForm.jsp"%>

    <div class="row">
        <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12"> 
            <div class="panel panel-default">
                <div class="panel-heading">
                    <div class="panel-title">
                        <a href="#" title="Close Search Criteria" aria-label="Close Search Criteria" class="vap-panel-hide-show"><i class="fa fa-minus" aria-hidden="true" data-panel-body="myReportSearchPanel"></i></a> Search Criteria
                    </div> 
                </div>   
                <div class="panel-body" id="myReportSearchPanel"> 
                    <form name="searchForm" class="form-horizontal">
                        <div id="errorMessage" class="alert alert-warning" style="display: none;" role="alert"></div>
                        <div class="row">
                            <div class="col-xs-6 col-sm-6 col-md-6 col-lg-6">
                                <div class="form-group">
                                    <label for="ssn" class="col-xs-3 col-sm-3 col-md-3 col-lg-3 control-label">SSN(s)</label>
                                    <div class="col-xs-6 col-sm-6 col-md-6 col-lg-6">
                                        <input class="form-control" data-tooltip="<c:out value="${descriptors['delayedConsentDetailReportSSNField']}" />" title="Enter SSN. Enter numbers only no hyphens" id="ssn" name="ssn" type="text" size="30" /> <i><span style="font-weight:normal;"> (Enter one or more SSN's, with no hyphens, separated by commas)</span></i> &nbsp;
                                    </div>
                                </div>
                                <div class="form-group">
                                    <label for="lastName" class="col-xs-3 col-sm-3 col-md-3 col-lg-3 control-label">Last Name</label>
                                    <div class="col-xs-6 col-sm-6 col-md-6 col-lg-6">
                                        <input class="form-control"data-tooltip="<c:out value="${descriptors['lastNameField']}" />" title="Enter Last Name" id="lastName" name="lastName" type="text" maxlength="255" size="30" />
                                    </div>
                                </div>
                                <div class="form-group">
                                    <label for="firstName" class="col-xs-3 col-sm-3 col-md-3 col-lg-3 control-label">First Name</label>
                                    <div class="col-xs-6 col-sm-6 col-md-6 col-lg-6">
                                        <input class="form-control" data-tooltip="<c:out value="${descriptors['firstNameField']}" />" title="Enter First Name" id="firstName" name="firstName" type="text" maxlength="255" size="30" />
                                    </div>
                                </div>
                                <jsp:include page="reporting/common/facilitiesFilter.jsp">
                                    <jsp:param name="defaultUserFacility" value="${defaultUserFacility}" />
                                    <jsp:param name="defaultUserFacilityName" value="${defaultUserFacilityName}" />
                                    <jsp:param name="defaultUserFacilityStation" value="${defaultUserFacilityStation}" />                                                                            
                                    <jsp:param name="facilityFilterTooltip" value="${facilityFilterTooltip}" />
                                    <jsp:param name="labelCols" value="3" />
                                    <jsp:param name="selectCols" value="6" />
                                </jsp:include>
                                <div class="form-group">
                                    <label for="enteredBy" class="col-xs-3 col-sm-3 col-md-3 col-lg-3 control-label">Entered By</label>
                                    <div class="col-xs-6 col-sm-6 col-md-6 col-lg-6">
                                        <input class="form-control" data-tooltip="<c:out value="${descriptors['delayedConsentDetailReportEnteredByField']}" />" title="Entered By" id="enteredBy" name="enteredBy" type="text" maxlength="255" size="30" />
                                    </div>
                                </div>
                            </div>    
                            <div class="col-xs-6 col-sm-6 col-md-6 col-lg-6">    
                                <div class="form-group">
                                    <fieldset>
                                        <legend class="col-xs-4 col-sm-4 col-md-4 col-lg-4 vap-input-group-legend">Reason(s) for Delay</legend>
                                        <div class="col-xs-6 col-sm-6 col-md-6 col-lg-6">
                                            <span data-tooltip="<c:out value="${descriptors['reasonsForDelayField']}" />" id="reasonsForDelayTip">
                                                <label class="vap-normal-font-weight" for="all"><input type="checkbox" value="ALL" class="allableCheckbox" id="all"> ALL</label><br />
                                                <c:forEach var="r" items="${reasons}" varStatus="i">
                                                    <label class="vap-normal-font-weight" for="<c:out value="${fn:replace(r.name, ' ', '')}" />"><input type="checkbox" value="<c:out value="${r.delayReasonId}" />" id="<c:out value="${fn:replace(r.name, ' ', '')}" />" class="allableCheckbox" /> <c:out value="${r.name}" /></label><br />  
                                                </c:forEach>
                                            </span>
                                        </div>
                                    </fieldset>
                                </div>
                                <div class="form-group">
                                    <label for="daysSinceDelayed" class="col-xs-4 col-sm-4 col-md-4 col-lg-4 control-label">Days Since Delayed</label>
                                    <div class="col-xs-5 col-sm-5 col-md-5 col-lg-5">
                                        <select class="form-control" data-tooltip="<c:out value="${descriptors['daysSinceDelayedField']}" />" id="daysSinceDelayed" name="daysSinceDelayed">
                                            <option value="ALL">ALL</option>
                                            <option value="0">0-5 days</option>
                                            <option value="5">&gt; 5 days</option>
                                            <option value="10">&gt; 10 days</option>
                                            <option value="15">&gt; 15 days</option>
                                            <option value="30">&gt; 30 days</option>
                                            <option value="60">&gt; 60 days</option>
                                            <option value="90">&gt; 90 days</option>
                                            <option value="120">&gt; 120 days</option>
                                        </select>
                                    </div>
                                </div>
                                <div class="form-group">
                                    <label for="consentType" class="col-xs-4 col-sm-4 col-md-4 col-lg-4 control-label">Consent Type</label>
                                    <div class="col-xs-5 col-sm-5 col-md-5 col-lg-5">
                                        <select class="form-control" data-tooltip="<c:out value="${descriptors['delayedConsentDetailReportConsentTypeField']}" />" id="consentType" name="consentType">
                                            <option value="ALL">ALL</option>
                                            <option value="NwHIN Authorization"><c:out value="${organizationName} Authorizations" /></option>
                                            <option value="SSA Authorization">SSA Authorizations</option>
                                        </select>
                                    </div>
                                </div>
                                <div class="form-group">
                                    <label for="patientTypes" class="col-xs-4 col-sm-4 col-md-4 col-lg-4 control-label">Patient Types</label>
                                    <div class="col-xs-5 col-sm-5 col-md-5 col-lg-5">
                                        <select class="form-control" data-tooltip="<c:out value="${descriptors['patientTypesField']}" />" id="patientTypes" name="patientTypes">
                                            <option value="3">ALL</option>
                                            <option value="1"selected>Real Patients</option>
                                            <option value="2">Test Patients</option>
                                        </select>
                                    </div>
                                </div>            
                            </div>
                        </div>
                    </form>
                    <div class="row">
                        <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12">
                            <div class="form-group">
                                <div class="text-right">
                                    <input id="searchButton" name="searchButton" title="Search" class="btn btn-primary" type="button" value="Search" />
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div><div aria-live="assertive" role="alert" id="reportTable_info"></div></div>
    <div id="results">
        <div class="panel panel-default" id="divReportPanel">
            <div class="panel-heading">
                <div class="panel-title">
                    <div class="pull-left">
                        <a href="#" title="Close Search Results" aria-label="Close Search Results" class="vap-panel-hide-show"><i class="fa fa-minus" aria-hidden="true" data-panel-body="myResultsPanel"></i></a> Search Results
                    </div>
                    <div class="pull-right"><!-- right align the buttons -->
                        <a href="#" data-toggle="modal" data-target="#confirmExportModal" data-method="exportToExcel" title="Export to Excel" class="pad-right-10"><i class="fa fa-download" aria-hidden="true"></i> Export to Excel</a>
                        <a href="#" data-toggle="modal" data-target="#confirmExportModal" data-method="exportToCsv" title="Export to CSV" class="pad-right-10"><i class="fa fa-download" aria-hidden="true"></i> Export to CSV</a>
                    </div>
                    <div class="clearfix"></div>
                </div>
            </div>   
            <div class="panel-body" id="myResultsPanel">
                <table id="reportTable" class="table table-striped" width="100%" cellspacing="0" role="presentation">
                    <thead>
                        <tr role="row">
                            <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['eventOccurredColumn']}" />" id="dateEnteredHeader">Date Entered (CT)</span></th>
                            <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['icnColumn']}" />" id="icnHeader">ICN</span></th>
                            <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['ssnColumn']}" />" id="ssnHeader">SSN</span></th>
                            <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['lastNameColumn']}" />" id="lastNameHeader">Last Name</span></th>
                            <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['firstNameColumn']}" />" id="firstNameHeader">First Name</span></th>
                            <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['middleNameColumn']}" />" id="middleNameHeader">Middle Name</span></th>
                            <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['delayedConsentDetailReportConsentTypeColumn']}" />" id="consentTypeHeader">Consent Type</span></th>
                            <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['reasonsForDelayColumn']}" />" id="reasonsForDelayHeader">Reason(s) for Delay</span></th>
                            <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['delayedConsentDetailReportEnteredByColumn']}" />" id="enteredByHeader">Entered By</span></th>
                            <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['delayedConsentDetailReportAuthenticatingFacilityColumn']}" />" id="authFacilityHeader">Authenticating Facility</span></th>
                            <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['delayedConsentDetailReporMailedDatesColumn']}" />" data-tooltip-position="left" id="mailedDatesHeader">Mailed Dates</span></th>
                        </tr>
                    </thead>
                </table>
            </div>
        </div> 
    </div>
</f:mainTemplate>