<%--
    Document   : delayedConsentSummaryReport
    Created on : Apr 5, 2016, 2:13:02 PM
    Author     : Irakli Kakushadze
--%>

<%@taglib tagdir="/WEB-INF/tags/formatting" prefix="f" %>
<%@page import="java.util.HashMap"%>
<%@page import="gov.va.nvap.svc.facility.data.Facility"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn" %>
<%@taglib tagdir="/WEB-INF/tags/cpp" prefix="cpp" %>

<%
    HashMap tips = (HashMap) session.getAttribute("descriptors");
    String facilityFilterTooltip = (String) tips.get("authenticatingFacilityField");
    Facility defaultUserFacility = (Facility) session.getAttribute("defaultUserFacility");
    String defaultUserFacilityName = defaultUserFacility == null ? "" : defaultUserFacility.getFacilityName();
    String defaultUserFacilityStation = defaultUserFacility == null ? "" : defaultUserFacility.getFacilityStation();
    pageContext.setAttribute("facilityFilterTooltip", facilityFilterTooltip);
    pageContext.setAttribute("defaultUserFacility", defaultUserFacility);
    pageContext.setAttribute("defaultUserFacilityName", defaultUserFacilityName);
    pageContext.setAttribute("defaultUserFacilityStation", defaultUserFacilityStation);
%> 

<f:mainTemplate headerText="Delayed Consent Summary Report">
    <script language="JavaScript">
        $(document).ready(function () {
            //check the ALL checkbox for the reasons on initial load
            $('.allableCheckbox[value=ALL]').prop("checked", true);

            VAP.common.setProcessingForDataTable('reportTable', 'divReportPanel');
            
            VAP.common.reportTable = $('#reportTable').DataTable({
                deferLoading: 0,
                destroy:true,
                searching: false,
                processing: true,
                serverSide: true,
                order: [[0, 'asc']],
                ajax: {
                    url: VAP.common.constructUrl("doSearch"),
                    dataSrc: function (json) {
                        $('.dataTables_empty').remove();
                        return json.data;
                    },
                    error: function (o) {
                        VAP.common.handleErrorsInDataTable('reportTable', o, 9, 'divReportPanel');
                    }
                },
                paging: false,
                info: false,
                columnDefs: [
                    {className: "text-right", targets: [2]}
                ],
                drawCallback: function () {
                    var api = this.api();

                    $(api.column(2).footer()).html(
                            api.column(2, {page: 'current'}).data().sum()
                            );
                }
            });

            VAP.common.reportTable.on('draw', function () {
                VAP.common.addAriaToDataTable('reportTable', VAP.common.reportTable);
                VAP.common.addSrollingToDataTable('reportTable');
            });
            
            $('#searchButton').on('click', function () {
                $('#reportTable .dataTables_empty').html(''); //blank out the empty table message if there is one
                
                $('#results').show();
                VAP.common.reportTable.ajax.url(VAP.common.constructUrl('doSearch')).load();
            });

            $('#results').hide();
        });
        
        VAP.common.constructUrl = function (methodName) {
            var reasonsForDelay = [];
            $('.allableCheckbox:checkbox:checked').each(function () {
                reasonsForDelay.push($(this).val());
            });

            var url = 'DelayedConsentSummaryReport.do_sec' +
                    '?' + methodName + '=true' +
                    '&stationNumbers=' + facilitiesDialog.getSelectedStationNumbers() +
                    '&aggregateAtFacilityLevel=' + facilitiesDialog.getAggregateAtFacilityLevel() +
                    '&includeUnknownVisn=' + facilitiesDialog.getIncludeUnknownVisn() +
                    '&reasonsForDelay=' + reasonsForDelay.toString() +
                    '&daysSinceDelayed=' + $('#daysSinceDelayed').val() +
                    '&consentType=' + $('#consentType').val() +
                    '&start=0' +
                    '&length=-1' +
                    '&sortBy=' + $('#reportTable').dataTable().fnSettings().aaSorting[0][0] +
                    '&sortOrder=' + $('#reportTable').dataTable().fnSettings().aaSorting[0][1] +
                    '&patientTypes=' + $('#patientTypes').val();

            return url;
        };
    </script>

    <div class="row">
        <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12">
            <div class="panel panel-default">
                <div class="panel-heading">
                    <div class="panel-title">
                        <a href="#" title="Close Search Criteria" aria-label="Close Search Criteria" class="vap-panel-hide-show"><i class="fa fa-minus" aria-hidden="true" data-panel-body="myReportSearchPanel"></i></a> Search Criteria
                    </div> 
                </div>   
                <div class="panel-body" id="myReportSearchPanel"> 
                    <form name="searchForm" class="form-horizontal">
                        <div id="errorMessage" class="alert alert-warning" style="display: none;" role="alert"></div>
                        <jsp:include page="reporting/common/facilitiesFilter.jsp">
                            <jsp:param name="defaultUserFacility" value="${defaultUserFacility}" />
                            <jsp:param name="defaultUserFacilityName" value="${defaultUserFacilityName}" />
                            <jsp:param name="defaultUserFacilityStation" value="${defaultUserFacilityStation}" />                                                                            
                            <jsp:param name="facilityFilterTooltip" value="${facilityFilterTooltip}" />
                        </jsp:include>
                        <div class="form-group">
                            <fieldset>
                                <legend class="col-xs-2 col-sm-2 col-md-2 col-lg-2 vap-input-group-legend">Reason(s) for Delay</legend>
                                <div class="col-xs-6 col-sm-6 col-md-6 col-lg-6">
                                    <span data-tooltip="<c:out value="${descriptors['reasonsForDelayField']}" />" id="reasonsForDelayTip">
                                        <label class="vap-normal-font-weight" for="all"><input type="checkbox" value="ALL" class="allableCheckbox" id="all"> ALL</label><br />
                                        <c:forEach var="r" items="${reasons}" varStatus="i">
                                            <label class="vap-normal-font-weight" for="<c:out value="${fn:replace(r.name, ' ', '')}" />"><input type="checkbox" value="<c:out value="${r.delayReasonId}" />" id="<c:out value="${fn:replace(r.name, ' ', '')}" />" class="allableCheckbox" /> <c:out value="${r.name}" /></label><br />  
                                        </c:forEach>
                                    </span>
                                </div>
                            </fieldset>
                        </div>
                        <div class="form-group">
                            <label for="daysSinceDelayed" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">Days Since Delayed</label>
                            <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                                <select  class="form-control" data-tooltip="<c:out value="${descriptors['daysSinceDelayedField']}"/>" id="daysSinceDelayed" name="daysSinceDelayed">
                                    <option value="ALL">ALL</option>
                                    <option value="0">0-5 days</option>
                                    <option value="5">&gt; 5 days</option>
                                    <option value="10">&gt; 10 days</option>
                                    <option value="15">&gt; 15 days</option>
                                    <option value="30">&gt; 30 days</option>
                                    <option value="60">&gt; 60 days</option>
                                    <option value="90">&gt; 90 days</option>
                                    <option value="120">&gt; 120 days</option>
                                </select>
                            </div>
                        </div>
                        <div class="form-group">
                            <label for="consentType" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">Consent Type</label>
                            <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                                <select class="form-control" data-tooltip="<c:out value="${descriptors['delayedConsentSummaryReportConsentTypeField']}"/>" id="consentType" name="consentType">
                                    <option value="ALL">ALL</option>
                                    <option value="NwHIN Authorization"><c:out value="${organizationName}"/> Authorizations</option>
                                    <option value="SSA Authorization">SSA Authorizations</option>
                                </select>
                            </div>
                        </div>
                        <div class="form-group">
                            <label for="patientTypes" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">Patient Types</label>
                            <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                                <select class="form-control" data-tooltip="<c:out value="${descriptors['patientTypesField']}"/>" id="patientTypes" name="patientTypes">
                                    <option value="3">ALL</option>
                                    <option value="1" selected>Real Patients</option>
                                    <option value="2">Test Patients</option>
                                </select>
                            </div>
                        </div>
                    </form>
                    <div class="form-group">
                        <div class="col-xs-6 col-sm-6 col-md-6 col-lg-6 text-right">
                            <input name="searchButton" id="searchButton" title="Search" class="btn btn-primary" type="button" value="Search" />
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div><div aria-live="assertive" role="alert" id="reportTable_info"></div></div>
    <div id="results">
        <div class="panel panel-default" id="divReportPanel">
            <div class="panel-heading">
                <div class="panel-title">
                    <div class="pull-left">
                        <a href="#" title="Close Search Results" aria-label="Close Search Results" class="vap-panel-hide-show"><i class="fa fa-minus" aria-hidden="true" data-panel-body="myResultsPanel"></i></a> Search Results
                    </div>
                    <div class="pull-right">
                        <a href="#" class="directDownload" data-method="exportToExcel" title="Export to Excel" class="pad-right-10"><i class="fa fa-download" aria-hidden="true"></i> Export to Excel</a>
                    </div>
                    <div class="clearfix"></div>
                </div>
            </div>   
            <div class="panel-body" id="myResultsPanel">
                <table id="reportTable" class="table table-striped" width="100%" cellspacing="0" role="presentation">
                    <thead>
                        <tr role="row">
                            <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['delayedConsentSummaryReportAuthenticatingFacilityColumn']}"/>" id="authenticatingFacilityHeader">Authenticating Facility</span></th>
                            <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['delayedConsentSummaryReportConsentTypeColumn']}"/>" id="consentTypeHeader"><b>Consent Type</b></span></th>
                            <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['delayedConsentSummaryReportTotalColumn']}"/>" data-tooltip-position="left" id="totalHeader"><b>Total</b></span></th>
                        </tr>
                    </thead>
                    <tfoot>
                        <tr role="row">
                            <td role="gridcell" class="bold text-left">Total:</td>
                            <td role="gridcell"></td>
                            <td role="gridcell" class="bold text-right"></td>
                        </tr>
                    </tfoot>
                </table>
            </div>
        </div> 
   </div>
</f:mainTemplate>