<%--
    Document   : Document Disclosure Report
    Created By : David Vasquez / Robert Snelling
    Modified By: Asha Amritraj
--%>

<%@taglib tagdir="/WEB-INF/tags/formatting" prefix="f" %>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<%@taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn" %>
<%@taglib tagdir="/WEB-INF/tags/cpp" prefix="cpp" %>
<%@taglib tagdir="/WEB-INF/tags/date" prefix="date" %>
<%@page import="java.util.*"%>
<%@page import="java.text.SimpleDateFormat"%>

<%    
    Date today = new Date();
    SimpleDateFormat ft = new SimpleDateFormat ("MM/dd/yyyy");
    String maxDate = ft.format(today);
    
    pageContext.setAttribute("maxDate", maxDate);
%>

<f:mainTemplate headerText="Accounting of Disclosures Report">
    <script language="JavaScript">
        $(document).ready(function () {
            $('#source').on('change', function () {
                handleSourceChange();
            });
                        
            /*$("#startDate").datepicker({
                maxDate: 0,
                dateFormat: 'mm/dd/yy',
                onClose: function (selectedDate) {
                    $("#endDate").datepicker("option", "minDate", selectedDate);
                    $(this).focus();
                }
            });

            $("#endDate").datepicker({
                maxDate: 0,
                dateFormat: 'mm/dd/yy',
                onClose: function (selectedDate) {
                    $("#startDate").datepicker("option", "maxDate", selectedDate);
                    $(this).focus();
                }
            });*/ 
        
            $('#startDate').datepicker({
                theme: 'vap',
                inputFormat: 'MM/dd/yyyy',
                outputFormat: 'MM/dd/yyyy',
                gainFocusOnConstruction: false,
                max: '<c:out value="${maxDate}" />',
                onUpdate: function(curValue) {
                    $('#endDate').datepicker('min', curValue);
                }
            });
            
            $('#endDate').datepicker({
                theme: 'vap',
                inputFormat: 'MM/dd/yyyy',
                outputFormat: 'MM/dd/yyyy',
                gainFocusOnConstruction: false,
                max: '<c:out value="${maxDate}" />',
                min: '<c:out value="${endDateDefault}" />', 
                onUpdate: function(curValue) {
                    $('#startDate').datepicker('max', curValue);
                }
            });
            
            VAP.common.constructUrl = function(methodName){
                var url = 'DocumentDisclosureReport.do_sec' +
                        '?' + methodName + '=true' +
                        '&ssn=' + $('#ssn').val() +
                        '&firstName=' + $('#firstName').val() +
                        '&lastName=' + $('#lastName').val() +
                        '&purposeOfUse=' + $('#purposeOfUse').val() +
                        '&source=' + $('#source').val() +
                        '&startDate=' + $('#startDate').val() +
                        '&endDate=' + $('#endDate').val() +
                        '&organization=' + $('#organization').val() +
                        '&organizationName=' + $('#organizationName').val() +
                        '&facility=' + $('#facility').val() +
                        '&facilityName=' + $('#facilityName').val() +
                        '&patientTypes=' + $('#patientTypes').val();

                if($('#source').val() === 'exchange') {
                    url = url + '&sortValue=' + $('#exchangeDataTable').dataTable().fnSettings().aaSorting[0][0] +
                    '&sortOrder=' + $('#exchangeDataTable').dataTable().fnSettings().aaSorting[0][1];
                } else {
                    url = url + '&sortValue=' + $('#directDataTable').dataTable().fnSettings().aaSorting[0][0] +
                    '&sortOrder=' + $('#directDataTable').dataTable().fnSettings().aaSorting[0][1];
                }
                if (methodName === 'exportToCsv' || methodName === 'exportToExcel') {
                    url = url + '&totalRows=' + VAP.common.reportTable.page.info().recordsTotal;
                }
                return url;
            };
            
            //initial data table setup and call for the first recordset
            buildTable(true);
            
            function buildTable(loadingPage) {
                if (loadingPage) {
                    VAP.common.setProcessingForDataTable('exchangeDataTable', 'divReportPanel');
                    
                    VAP.common.reportTable = $('#exchangeDataTable').DataTable({
                        deferLoading: 0,
                        destroy: true,
                        ajax: { 
                            url: VAP.common.constructUrl("doSearch"),
                            dataSrc: function(json){
                                $('.dataTables_empty').remove();
                                return json.data;
                            },
                            error: function(o){
                                VAP.common.handleErrorsInDataTable('exchangeDataTable', o, 12, 'divReportPanel');
                            }
                        }, 
                        info: true,
                        dom: "<'row'<'col-sm-12'l>>" +
                        "<'row'<'col-sm-6'i><'col-sm-6'p>>" +
                        "<'row'<'col-sm-12't<'pad-bottom-20'>r>>" +
                        "<'row'<'col-sm-5'i><'col-sm-7'p>>",
                        lengthMenu: [ 10, 25, 50, 100, 250, 500 ],
                        pageLength: 25,
                        processing: true,
                        searching: false,
                        serverSide: true,
                        columnDefs: [
                            {orderable: false, targets: [10, 11]},
                            {
                                targets: 11,
                                data: null,
                                render: function(data,type,full,meta){
                                    return '<a href="#/" onclick="documentView(\''+data[11]+'\', \''+data[12]+'\');">view</a>';
                                }
                            },
                            {
                                targets: 0,
                                data: null,
                                render: function(data,type,full,meta){
                                    return '<a href="#/" onclick="linkToPatient(\''+data[13]+'\', \''+data[1]+'\', \''+data[2]+'\');">'+data[0]+'</a>';
                                }
                            },
                            {className: 'vap-col-min-80', targets: 0},
                            {className: 'vap-col-min-130', targets: [3,4]},
                            {className: 'vap-col-min-150', targets: [5,7]},
                            {className: 'text-center vertical-align-center', targets: [11]} 
                        ],
                        initComplete: function(){
                            // Enable THEAD scroll bars
                            $('.dataTables_scrollHead').css('overflow', 'auto');

                            // Sync THEAD scrolling with TBODY
                            $('.dataTables_scrollHead').on('scroll', function () {
                                $('.dataTables_scrollBody').scrollLeft($(this).scrollLeft());
                            });
                        },
                        order: [[3, "desc"]]
                    });
                } else if ($('#source').val() === 'exchange') {
                    VAP.common.setProcessingForDataTable('exchangeDataTable', 'divReportPanel');
                    
                    VAP.common.reportTable = $('#exchangeDataTable').DataTable({
                        destroy: true,
                        ajax: { 
                            url: VAP.common.constructUrl("doSearch"),
                            dataSrc: function(json){
                                $('.dataTables_empty').remove();
                                return json.data;
                            },
                            error: function(o){
                                VAP.common.handleErrorsInDataTable('exchangeDataTable', o, 12, 'divReportPanel');
                            }
                        }, 
                        info: true,
                        dom: "<'row'<'col-sm-12'l>>" +
                        "<'row'<'col-sm-6'i><'col-sm-6'p>>" +
                        "<'row'<'col-sm-12't<'pad-bottom-20'>r>>" +
                        "<'row'<'col-sm-5'i><'col-sm-7'p>>",
                        lengthMenu: [ 10, 25, 50, 100, 250, 500 ],
                        pageLength: 25,
                        processing: true,
                        searching: false,
                        serverSide: true,
                        columnDefs: [
                            {orderable: false, targets: [10, 11]},
                            {
                                targets: 11,
                                data: null,
                                render: function(data,type,full,meta){
                                    return '<a href="#/" class="btn btn-xs btn-primary" onclick="documentView(\''+data[11]+'\', \''+data[12]+'\');">View</a>';
                                }
                            },
                            {
                                targets: 0,
                                data: null,
                                render: function(data,type,full,meta){
                                    return '<a href="#/" onclick="linkToPatient(\''+data[13]+'\', \''+data[1]+'\', \''+data[2]+'\');">'+data[0]+'</a>';
                                }
                            },
                            {className: 'vap-col-min-80', targets: 0},
                            {className: 'vap-col-min-130', targets: [3,4]},
                            {className: 'vap-col-min-150', targets: [5,7]},
                            {className: 'text-center vertical-align-center', targets: [11]} 
                        ],
                        order: [[3, "desc"]]
                    });
                } else {
                    VAP.common.setProcessingForDataTable('directDataTable', 'divReportPanel');
                    
                    VAP.common.reportTable = $('#directDataTable').DataTable({
                        destroy: true,
                        ajax: { 
                            url: VAP.common.constructUrl("doSearch"),
                            dataSrc: function(json){
                                $('.dataTables_empty').remove();
                                return json.data;
                            },
                            error: function(o){
                                VAP.common.handleErrorsInDataTable('directDataTable', o, 8, 'divReportPanel');
                            }
                        }, 
                        info: false,
                        dom: 'lipt<"pad-bottom-20">ipr',
                        lengthMenu: [ 10, 25, 50, 100, 250, 500 ],
                        pageLength: 25, 
                        processing: true,
                        searching: false,
                        serverSide: true,
                        columnDefs: [
                            {
                                targets: 0,
                                data: null,
                                render: function(data,type,full,meta){
                                    return '<a href="#/" onclick="linkToPatient(\''+data[8]+'\', \''+data[1]+'\', \''+data[2]+'\');">'+data[0]+'</a>';
                                }
                            },
                            {className: 'vap-col-min-80', targets: 0},
                            {className: 'vap-col-min-150', targets: [3,4,5]}
                        ],
                        order: [[3, "desc"]] 
                    });
                }
            }

            // DataTable overrides
            VAP.common.reportTable.on('draw', function () {
                VAP.common.addAriaToDataTable('exchangeDataTable', VAP.common.reportTable);
                VAP.common.addAriaToDataTable('directDataTable', VAP.common.reportTable);
                VAP.common.addSrollingToDataTable('exchangeDataTable');
                VAP.common.addSrollingToDataTable('directDataTable');
            });

            $('#searchButton').on('click', function () {
                $('#exchangeDataTable .dataTables_empty').html(''); //blank out the empty table message if there is one
                $('#directDataTable .dataTables_empty').html(''); //blank out the empty table message if there is one
                
                var startDate = $('#startDate').val();
                var endDate = $('#endDate').val();

                var errorMessage = VAP.common.validateStartAndEndDate(startDate, endDate);
                
                if (errorMessage != '')
                {
                    //we have an error so show the error, and then don't send the ajax request
                    $('#errorMessage').html(errorMessage);
                    $('#errorMessage').show();

                    return false;
                } else {
                    //no error, let's make the call to populate the report
                    $('#results').show();
                    buildTable(false);
                }
            });

            $('#printReport').on('click', function () {
                window.print();
            });

            $('#startDate,#endDate').on('change', function () {
                //if either date changes, hide the error message if its not already hidden
                $('#errorMessage').hide();
            });
            
            handleSourceChange();
            
            $('#results').hide();
        });
        
        //Used by 'view' button in exchange final table column
        function documentView(documentIcn, documentUniqueID) {
            $('#document-View-ICN').val(documentIcn);
            $('#document-View-Unique-Id').val(documentUniqueID);
            document.getElementById('documentViewForm').submit();
        }

        handleSourceChange = function() {
            if ($('#source option:selected').val() === 'exchange') {
                $("#facilityDiv").show();
                $("#organizationDiv").show();
                $("#patientTypesDiv").show();
                $("#exchangeDataTable_wrapper").show();
                $("#exchangeDataTable").show();
                $("#directDataTable_wrapper").hide();
                $("#directDataTable").hide();
            } else {
                $("#facilityDiv").hide();
                $("#organizationDiv").hide();
                $("#patientTypesDiv").hide();
                $("#exchangeDataTable_wrapper").hide();
                $("#exchangeDataTable").hide();
                $("#directDataTable_wrapper").show();
                $("#directDataTable").show();
            }
        };
    </script>

    <div class="row">
        <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12">
            <div class="panel panel-default">
                <div class="panel-heading">
                    <div class="panel-title">
                        <a href="#" title="Close Search Criteria" aria-label="Close Search Criteria" class="vap-panel-hide-show"><i class="fa fa-minus" aria-hidden="true" data-panel-body="documentDisclosureReportSearchPanel"></i></a> Search Criteria
                    </div>
                </div>    
                <div class="panel-body" id="documentDisclosureReportSearchPanel">
                    <div class="alert alert-info">
                        Fill in the fields below to narrow your search. All dates will be included if Start Date and End Date are left blank.
                    </div>
                    <div id="errorMessage" class="alert alert-warning pad-15 margin-bottom-10" style="display: none;" role="alert"></div>
                    <form name="documentDisclosureReportForm" action="DocumentDisclosureReport.do_sec" method="POST" class="form-horizontal" role="form">
                        <input type="hidden" id="organizationName" name="organizationName" />
                        <input type="hidden" id="facilityName" name="facilityName" />
                        
                        <div class="row">
                            <div class="col-xs-5 col-sm-5 col-md-5 col-lg-5">
                                <div class="form-group">
                                    <label for="source" class="col-xs-4 col-sm-4 col-md-4 col-lg-4 control-label">Disclosure Source</label>
                                    <div class="col-xs-6 col-sm-6 col-md-6 col-lg-6">
                                        <select id="source" name="source" onchange="handleSourceChange();" class="form-control" data-tooltip="<c:out value="${descriptors['disclosureSourceField']}"/>">
                                            <option value="exchange" selected>Exchange</option>
                                            <option value="direct">Direct</option>
                                        </select>
                                    </div>
                                </div>
                                <div class="form-group">
                                    <label for="ssn" class="col-xs-4 col-sm-4 col-md-4 col-lg-4 control-label">SSN</label>
                                    <div class="col-xs-6 col-sm-6 col-md-6 col-lg-6">
                                        <input title="Enter SSN. Enter numbers only no hyphens" id="ssn" name="ssn" type="text" maxlength="9" size="9" data-tooltip="<c:out value="${descriptors['ssnField']}"/>" placeholder="#########" class="form-control" />
                                    </div>
                                </div>
                                <div class="form-group">
                                    <label for="lastName" class="col-xs-4 col-sm-4 col-md-4 col-lg-4 control-label">Last Name</label>
                                    <div class="col-xs-6 col-sm-6 col-md-6 col-lg-6">
                                        <input title="Enter Last Name" id="lastName" name="lastName" type="text" maxlength="255" size="30" data-tooltip="<c:out value="${descriptors['lastNameField']}"/>" class="form-control" />
                                    </div>
                                </div>
                                <div class="form-group">
                                    <label for="firstName" class="col-xs-4 col-sm-4 col-md-4 col-lg-4 control-label">First Name</label>
                                    <div class="col-xs-6 col-sm-6 col-md-6 col-lg-6">
                                        <input title="Enter First Name" id="firstName" name="firstName" type="text" maxlength="255" size="30" data-tooltip="<c:out value="${descriptors['firstNameField']}"/>" class="form-control" />
                                    </div>
                                </div>
                                <div class="form-group">
                                    <label for="startDate" class="col-xs-4 col-sm-4 col-md-4 col-lg-4 control-label">Start Date</label>
                                    <div class="col-xs-6 col-sm-6 col-md-6 col-lg-6" data-tooltip="<c:out value="${descriptors['startDateEndDateField']}" />">
                                        <input type="text" name="startDate" id="startDate" class="form-control" value="<c:out value="${endDateDefault}" />" />
                                    </div>
                                </div>
                                <div class="form-group">
                                    <label for="endDate" class="col-xs-4 col-sm-4 col-md-4 col-lg-4 control-label">End Date</label>
                                    <div class="col-xs-6 col-sm-6 col-md-6 col-lg-6" data-tooltip="<c:out value="${descriptors['startDateEndDateField']}" />">
                                        <input type="text" name="endDate" id="endDate" class="form-control" value="<c:out value="${endDateDefault}" />" />
                                    </div>
                                </div>
                            </div>
                            <div class="col-xs-7 col-sm-7 col-md-7 col-lg-7">
                                <c:if test="${pouFlag eq true}">
                                    <div class="form-group">
                                        <label for="purposeOfUse" class="col-xs-3 col-sm-3 col-md-3 col-lg-3 control-label">Purpose of Use</label>
                                        <div class="col-xs-7 col-sm-7 col-md-7 col-lg-7">
                                            <select id="purposeOfUse" name="purposeOfUse" data-tooltip="<c:out value="${descriptors['purposeOfUseField']}"/>" class="form-control">
                                                <option value="">ALL</option>
                                                <c:forEach var="pou" items="${pous}">
                                                    <option value="<c:out value="${pou.pouValue}" />"><c:out value="${pou.pouValue}" /></option>
                                                </c:forEach>
                                            </select>
                                        </div>
                                    </div>
                                </c:if>
                                <div id="facilityDiv" class="form-group">
                                    <label for="facility" class="col-xs-3 col-sm-3 col-md-3 col-lg-3 control-label">Patient Preferred Facility</label>
                                    <div class="col-xs-7 col-sm-7 col-md-7 col-lg-7">
                                        <select id="facility" name="facility" onchange="document.getElementById('facilityName').value = this.options[this.selectedIndex].text;" data-tooltip="<c:out value="${descriptors['patientPreferredFacilityFilter']}"/>" class="form-control">
                                            <option value="">ALL</option>
                                            <c:forEach var="f" items="${facilities}">
                                                <option value="<c:out value="${f.facilityStation}" />"
                                                    <c:choose>
                                                        <c:when test="${f.facilityStation eq defaultUserFacility.facilityStation}">
                                                            selected
                                                        </c:when>
                                                        <c:when test="${cookie.facility.value == f.facilityStation}">
                                                            selected
                                                        </c:when>
                                                    </c:choose>>
                                                    <c:choose>
                                                        <c:when test="${f.facilityName != ''}">
                                                            <c:out value="${f.facilityName}" />
                                                        </c:when>
                                                        <c:otherwise>
                                                            <c:out value="${fn:split(f.facilityDns, '.')[0]}" />
                                                        </c:otherwise>
                                                    </c:choose>
                                                    (<c:out value="${f.facilityStation}" />)
                                                </option>
                                            </c:forEach>
                                        </select>
                                    </div>
                                </div>
                                <div id="organizationDiv" class="form-group">
                                    <label for="organization" class="col-xs-3 col-sm-3 col-md-3 col-lg-3 control-label">Organization</label>
                                    <div class="col-xs-7 col-sm-7 col-md-7 col-lg-7">
                                        <select id="organization" name="organization" onchange="document.getElementById('organizationName').value = this.options[this.selectedIndex].text;" data-tooltip="<c:out value="${descriptors['accountingOfDisclosuresReportOrganizationField']}"/>" class="form-control">
                                            <option value="" selected>ALL</option>
                                            <c:forEach var="r" items="${activeOrgs}">
                                                <option value="%<c:out value="${r.orgOid}" />"><c:out value="${r.orgName}" /></option>
                                            </c:forEach>
                                            <c:forEach var="r" items="${inactiveOrgs}">
                                                <option value="%<c:out value="${r.orgOid}" />">[INACTIVE] <c:out value="${r.orgName}" /></option>
                                            </c:forEach>
                                        </select>
                                    </div>
                                </div>
                                <div id="patientTypesDiv" class="form-group">
                                    <label for="patientTypes" class="col-xs-3 col-sm-3 col-md-3 col-lg-3 control-label">Patient Types</label>
                                    <div class="col-xs-7 col-sm-7 col-md-7 col-lg-7">
                                        <select id="patientTypes" name="patientTypes" data-tooltip="<c:out value="${descriptors['patientTypesField']}"/>" class="form-control">
                                            <option value="3">ALL</option>
                                            <option value="1" selected>Real Patients</option>
                                            <option value="2">Test Patients</option>
                                        </select>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </form>                       
                    <div class="row">
                        <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12">
                            <div class="form-group">
                                <div class="text-right">
                                    <input id="searchButton" name="search" title="Search" class="btn btn-primary" type="button" value="Search" />
                                </div>
                            </div>
                        </div>
                    </div>     
                </div>
            </div>
        </div>
    </div>
    <div><div aria-live="assertive" role="alert" id="reportTable_info"></div></div>
    <div id="results">
        <div class="row">
            <%@include file="patientLinkForm.jsp"%>
            <div id="divReportContent" class="col-xs-12 col-sm-12 col-md-12 col-lg-12">
                <div class="panel panel-default" id="divReportPanel">
                    <div class="panel-heading">
                        <div class="panel-title">
                            <div class="pull-left">
                                <a href="#" title="Close Search Results" aria-label="Close Search Results" class="vap-panel-hide-show"><i class="fa fa-minus" aria-hidden="true" data-panel-body="documentDisclosureReportResultsPanel"></i></a> Search Results
                            </div>
                            <div class="pull-right">
                                <a href="#" data-toggle="modal" data-target="#confirmExportModal" data-method="exportToExcel" title="Export to Excel" class="pad-right-10"><i class="fa fa-download" aria-hidden="true"></i> Export to Excel</a>
                                <a href="#" data-toggle="modal" data-target="#confirmExportModal" data-method="exportToCsv" title="Export to CSV" class="pad-right-10"><i class="fa fa-download" aria-hidden="true"></i> Export to CSV</a>
                                <a href="#" id="printReport" title="Print"><i class="fa fa-print" aria-hidden="true"></i> Print</a>
                            </div>
                            <div class="clearfix"></div>
                        </div>
                    </div>    
                    <div class="panel-body" id="documentDisclosureReportResultsPanel">
                        <form action="DocumentDisclosureReport.do_sec" method="POST" target="_blank" onsubmit="return doSubmit(this)" id="documentViewForm">
                            <input type="hidden" name="view" value="true">
                            <input type="hidden" name="documentIcn"  value="" id="document-View-ICN">
                            <input type="hidden" name="documentUniqueId" value="" id="document-View-Unique-Id">
                        </form>

                        <table id="exchangeDataTable" class="table table-striped" width="100%" cellspacing="0" role="presentation">
                            <thead>
                                <tr role="row">
                                    <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['ssnColumn']}"/>">SSN</span></th>
                                    <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['lastNameColumn']}"/>">Patient Last Name</span></th>
                                    <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['firstNameColumn']}"/>">Patient First Name</span></th>
                                    <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['eventOccurredColumn']}"/>">Date of Disclosures (CT)</span></th>
                                    <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['disclosureColumn']}"/>">Disclosures</span></th>
                                    <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['disclosureReportFacilityColumn']}"/>">Patient Preferred Facility</span></th>
                                    <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['patientPreferredFacilityStationIdColumn']}"/>">Patient Preferred Facility Station ID</span></th>
                                    <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['accountingOfDisclosuresReportOrganization']}"/>">eHealth Exchange Organization</span></th>
                                    <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['disclosuresUserIdColumn']}"/>">User ID</span></th>
                                    <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['purposeOfUseColumn']}"/>">Purpose of Use</span></th>
                                    <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['disclosureDetailedReportUserRoleColumn']}"/>" data-tooltip-position="left">User Role</span></th>
                                    <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['genericViewColumn']}"/>" data-tooltip-position="left">View</span></th>
                                </tr>
                            </thead>
                        </table>
                        <div aria-live="polite" role="status" id="directDataTable_info" class="dataTables_info hidden">Shows entries for Direct</div><%-- because we don't have the "Showing x of x" turned on for this table, we need this here to support aria --%> 
                        <table id="directDataTable" class="table table-striped" width="100%" cellspacing="0" role="presentation">
                            <thead>
                                <tr role="row">
                                    <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['ssnColumn']}"/>">SSN</span></th>
                                    <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['lastNameColumn']}"/>">Patient Last Name</span></th>
                                    <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['firstNameColumn']}"/>">Patient First Name</span></th>
                                    <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['eventOccurredColumn']}"/>">Date of Disclosures (CT)</span></th>
                                    <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['disclosureColumn']}"/>">Disclosures</span></th>
                                    <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['disclosuresDirectAddress']}"/>">Direct Address</span></th>
                                    <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['disclosuresUserIdColumn']}"/>">User ID</span></th>
                                    <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['purposeOfUseColumn']}"/>">Purpose of Use</span></th>
                                </tr>
                            </thead>
                        </table>
                    </div>
                </div>
            </div>
        </div>
    </div>
</f:mainTemplate>