<%--
    Document   : Opt-in/Opt-out Report
    Created By : David Vasquez / Robert Snelling
    Modified By: Asha Amritraj, Stephen Miller, Darren Henderson
--%>
<%@page import="gov.va.nvap.svc.facility.data.Facility"%>
<%@page import="java.util.*"%>
<%@page import="java.text.SimpleDateFormat"%>
<%@page trimDirectiveWhitespaces="true" %>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<%@taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn" %>
<%@taglib tagdir="/WEB-INF/tags/cpp" prefix="cpp" %>
<%@taglib tagdir="/WEB-INF/tags/date" prefix="date" %>
<%@taglib tagdir="/WEB-INF/tags/formatting" prefix="f" %>

<%
    HashMap tips = (HashMap) session.getAttribute("descriptors");
    String facilityFilterTooltip = (String) tips.get("authenticatingFacilityField");
    Facility defaultUserFacility = (Facility) session.getAttribute("defaultUserFacility");
    String defaultUserFacilityName = defaultUserFacility == null ? "" : defaultUserFacility.getFacilityName();
    String defaultUserFacilityStation = defaultUserFacility == null ? "" : defaultUserFacility.getFacilityStation();
    pageContext.setAttribute("facilityFilterTooltip", facilityFilterTooltip);
    pageContext.setAttribute("defaultUserFacility", defaultUserFacility);
    pageContext.setAttribute("defaultUserFacilityName", defaultUserFacilityName);
    pageContext.setAttribute("defaultUserFacilityStation", defaultUserFacilityStation);
    
    Date today = new Date();
    SimpleDateFormat ft = new SimpleDateFormat ("MM/dd/yyyy");
    String maxDate = ft.format(today);
    
    pageContext.setAttribute("maxDate", maxDate);
%>  

<f:mainTemplate headerText="Consent Directive Report">
    <script language="JavaScript">
        //Used by 'view' button in exchange final table column
        function documentView(documentUniqueID) {
            $('#documentUniqueId').val(documentUniqueID);
            document.getElementById('documentViewForm').submit();
        }

        $(document).ready(function () {
            /*$("#startDate").datepicker({
                maxDate: 0,
                dateFormat: 'mm/dd/yy',
                onClose: function (selectedDate) {
                    $("#endDate").datepicker("option", "minDate", selectedDate);
                    $(this).focus();
                }
            });

            $("#endDate").datepicker({
                maxDate: 0,
                dateFormat: 'mm/dd/yy',
                onClose: function (selectedDate) {
                    $("#startDate").datepicker("option", "maxDate", selectedDate);
                    $(this).focus();
                }
            });*/
        
            $('#startDate').datepicker({
                theme: 'vap',
                inputFormat: 'MM/dd/yyyy',
                outputFormat: 'MM/dd/yyyy',
                gainFocusOnConstruction: false,
                max: '<c:out value="${maxDate}" />',
                onUpdate: function(curValue) {
                    $('#endDate').datepicker('min', curValue);
                }
            });
            
            $('#endDate').datepicker({
                theme: 'vap',
                inputFormat: 'MM/dd/yyyy',
                outputFormat: 'MM/dd/yyyy',
                gainFocusOnConstruction: false,
                max: '<c:out value="${maxDate}" />',
                onUpdate: function(curValue) {
                    $('#startDate').datepicker('max', curValue);
                }
            });

            $('#ssn').focus();

            $('#consentType').on('change', function (e) {
                if ($(this).val().toLowerCase().indexOf('revocations') > -1) {
                    $('#inactivationReasonDiv').show();
                } else {
                    $('#inactivationReasonDiv').hide();
                    $('#inactivationReason').val('');
                }
            });

            VAP.common.setProcessingForDataTable('reportTable', 'divReportPanel');
            
            VAP.common.reportTable = $('#reportTable').DataTable({
                deferLoading: 0,
                destroy: true,
                ajax: {
                    url: VAP.common.constructUrl('doSearch')
                },
                dom: "<'row'<'col-sm-12'l>>" +
                        "<'row'<'col-sm-6'i><'col-sm-6'p>>" +
                        "<'row'<'col-sm-12't<'pad-bottom-20'>r>>" +
                        "<'row'<'col-sm-5'i><'col-sm-7'p>>",
                serverSide: true,
                processing: true,
                searching: false,
                lengthMenu: [10, 25, 50, 100, 250, 500],
                columnDefs: [
                    {orderable: false, targets: [12]},
                    {
                        targets: 0,
                        data: null,
                        render: function (data, type, full, meta) {
                            return '<a href="#/" onclick="linkToPatient(\'' + data[13] + '\', \'' + data[1] + '\', \'' + data[2] + '\');">' + data[0] + '</a>';
                        }
                    },
                    {
                        targets: 12,
                        data: null,
                        render: function (data, type, full, meta) {
                            //Not all rows have attachments so display nothing if thats the case
                            if (data[14] && "true" === data[14]) {
                                return '<a class="btn btn-xs btn-primary" href="#/" onclick="documentView(\'' + data[12] + '\');">View</a>';
                            } else if(data[6] === '<c:out value="${organizationName}"/> Organization Restriction Authorization') {
                                return '<button class="btn btn-primary btn-xs" data-toggle="modal" data-target="#restrictionsListModal" data-consent-audit-id="' + data[12] + '">View Restrictions</button>';
                            } else {
                                return "N/A";
                            }
                        }
                    },
                    {className: "vap-col-min-80", targets: [0, 7]},
                    {className: "vap-col-min-100", targets: 6},
                    {className: "vap-col-min-130", targets: [3, 9]},
                    {className: "vap-col-min-150", targets: 11},
                    {className: 'text-center vertical-align-center', targets: [12]}
                ],
                pageLength: 25,
                order: [[3, "desc"]]
            });
            
            VAP.common.reportTable.on('draw', function () {
                VAP.common.addAriaToDataTable('reportTable', VAP.common.reportTable);
                VAP.common.addSrollingToDataTable('reportTable');
            });

            $('#searchButton').on('click', function (event) {
                $('#reportTable .dataTables_empty').html(''); //blank out the empty table message if there is one
                
                var startDate = $('#startDate').val();
                var endDate = $('#endDate').val();

                var errorMessage = VAP.common.validateStartAndEndDate(startDate, endDate);

                if (errorMessage !== '') {
                    //we have an error so show the error, and then don't send the ajax request
                    $('#errorMessage').html(errorMessage);
                    $('#errorMessage').show();
                } else if($('#optInOptOutReportForm').validator('validate').has('.has-error').length) {
                    $('#errorMessage').html('If SSN is specified, the format must be ######### (numbers only, no hyphens).');
                    $('#errorMessage').show();
                } else {
                    //no error, let's make the call to populate the report
                    $('#errorMessage').hide();
                    $('#results').show();
                    VAP.common.reportTable.ajax.url(VAP.common.constructUrl('doSearch')).load();
                }
            });

            $('#startDate,#endDate').on('change', function () {
                //if either date changes, hide the error message if its not already hidden
                $('#errorMessage').hide();
            });
            
            $('#restrictionsListModal').on('show.bs.modal', function (event) {
                var button = $(event.relatedTarget);
                var consentAuditId = button.data("consent-audit-id");
                var url = 'OptInOptOutReport.do_sec?getRestrictionsList=true&consentAuditId=' + consentAuditId;
                
                var modalBody = $(this).find('.modal-body');
                
                modalBody.load(url, {spinnerTargetElement : 'restrictionsListModalBody'});
            });
            
            $('#restrictionsListModal').on('hidden.bs.modal', function(event) {
                var modalBody = $(this).find('.modal-body');
                
                //clear out the contents of this modal to we don't happen to see anything on load the next time it loads
                modalBody.html('');
            });
            
            $('#results').hide();
        });

        VAP.common.constructUrl = function (methodName) {
            var url = 'OptInOptOutReport.do_sec?' + methodName + '=true' +
                    '&ssn=' + $('#ssn').val() +
                    '&lastName=' + $('#lastName').val() +
                    '&firstName=' + $('#firstName').val() +
                    '&userId=' + $('#enteredBy').val() +
                    '&startDate=' + $('#startDate').val() +
                    '&endDate=' + $('#endDate').val() +
                    '&patientTypes=' + $('#patientTypes').val() +
                    '&consentType=' + $('#consentType').val() +
                    '&stationNumbers=' + facilitiesDialog.getSelectedStationNumbers() +
                    '&inactivationReason=' + $('#inactivationReason').val() +
                    '&consentTypeName=' + $('#consentTypeName').val() +
                    '&includeUnknownVisn=' + facilitiesDialog.getIncludeUnknownVisn() +
                    '&sortBy=' + $('#reportTable').dataTable().fnSettings().aaSorting[0][0] +
                    '&sortOrder=' + $('#reportTable').dataTable().fnSettings().aaSorting[0][1] +
                    '&enteredBy=' + $('#enteredBy').val();

            if (methodName === 'exportToCsv' || methodName === 'exportToExcel') {
                url = url + '&totalRows=' + VAP.common.reportTable.page.info().recordsTotal;
            }
            return url;
        };
    </script>

    <cpp:errors />

    <div class="row">
        <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12">
            <div class="panel panel-default">
                <div class="panel-heading">
                    <div class="panel-title">
                        <a href="#" title="Close Search Criteria" aria-label="Close Search Criteria" class="vap-panel-hide-show"><i class="fa fa-minus" aria-hidden="true" data-panel-body="myReportSearchPanel"></i></a> Search Criteria
                    </div>
                </div>   
                <div class="panel-body" id="myReportSearchPanel"> 
                    <div class="alert alert-info">
                        Fill in the fields below to narrow your search. All dates will be included if Start Date and End Date are left blank.
                    </div>
                    <div id="errorMessage" class="alert alert-warning" style="display: none;" role="alert"></div>
                    <form class="form-horizontal" data-toggle="validator" role="form" name="optInOptOutReportForm" id="optInOptOutReportForm">
                        <input type="hidden" id="consentTypeName" name="consentTypeName" />
                        <div class="form-group">
                            <label for="ssn" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">SSN <i><span style="font-weight:normal;"></span></i></label>
                            <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                                <input class="form-control" pattern="(^$)|(\d{9})" title="Enter SSN. Enter numbers only no hyphens" id="ssn" name="ssn" type="text" maxlength="9" size="9" placeholder="#########" data-tooltip="<c:out value="${descriptors['ssnField']}" />"/>
                            </div>
                        </div>
                        <div class="form-group">
                            <label for="lastName" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">Last Name</label>
                            <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                                <input class="form-control" title="Enter Last Name" id="lastName" name="lastName" type="text" maxlength="255" size="30" data-tooltip="<c:out value="${descriptors['lastNameField']}" />"/>
                            </div>
                        </div>
                        <div class="form-group">
                            <label for="firstName" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">First Name</label>
                            <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                                <input class="form-control" title="Enter First Name" id="firstName" name="firstName" type="text" maxlength="255" size="30" data-tooltip="<c:out value="${descriptors['firstNameField']}" />"/>
                            </div>
                        </div>
                        <div class="form-group">
                            <label for="startDate" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">Start Date</label>
                            <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3" data-tooltip="<c:out value="${descriptors['startDateEndDateField']}" />">
                                <input type="text" name="startDate" id="startDate" class="form-control" value="<c:out value="${startDateDefault}" />" />
                            </div>
                        </div>
                        <div class="form-group">
                            <label for="endDate" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">End Date</label>
                            <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3" data-tooltip="<c:out value="${descriptors['startDateEndDateField']}" />">
                                <input type="text" name="endDate" id="endDate" class="form-control" value="<c:out value="${endDateDefault}" />" />
                            </div>
                        </div>
                        <jsp:include page="reporting/common/facilitiesFilter.jsp">
                            <jsp:param name="defaultUserFacility" value="${defaultUserFacility}" />
                            <jsp:param name="defaultUserFacilityName" value="${defaultUserFacilityName}" />
                            <jsp:param name="defaultUserFacilityStation" value="${defaultUserFacilityStation}" />                                                                            
                            <jsp:param name="facilityFilterTooltip" value="${facilityFilterTooltip}" />
                        </jsp:include>        
                        <div class="form-group">
                            <label for="consentType" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">Consent Type <span style="display:none;">"Query based on consent type from the dropdown list"</span></label>
                            <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                                <select  class="form-control" id="consentType" name="consentType" document.getElementById('consentTypeName').value = this.options[this.selectedIndex].text;" data-tooltip="<c:out value="${descriptors['consentTypeField']}" />">
                                         <option value="" selected>ALL</option>
                                    <option value="allAuthorizations">ALL Authorizations</option>
                                    <option value="allRevocations" >ALL Revocations</option>
                                    <option value="NwHINAuthorizations" ><c:out value="${organizationName}"/> Authorizations</option>
                                    <option value="SSAAuthorizations" >SSA Authorizations</option>
                                    <option value="NwHINRevocations" ><c:out value="${organizationName}"/> Revocations</option>
                                    <option value="SSARevocations" >SSA Revocations</option>
                                    <option value="NwHINRestrictions" ><c:out value="${organizationName}"/> Restrictions</option>
                                    <option value="NwHINRestrictionRevocations" ><c:out value="${organizationName}"/> Restriction Revocations</option>
                                </select>
                            </div>
                        </div>
                        <div id="inactivationReasonDiv" style="display: none;" class="form-group">
                            <label for="inactivationReason" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">Inactivation Reason<span style="display:none;">"Query based on Authorization or Revocation from the dropdown list"</span></label>
                            <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                                <select class="form-control" id="inactivationReason" name="inactivationReason">
                                    <option value="" selected>ALL</option>
                                    <option value="New Authorization">New Authorization</option>
                                    <option value="Patient Deceased" >Patient Deceased</option>
                                    <option value="Entered in Error" >Entered in Error</option>
                                    <option value="Authorization Expired" >Authorization Expired</option>
                                    <option value="Revoked" >Revoked</option>
                                </select>
                            </div>
                        </div>
                        <div class="form-group">
                            <label for="enteredBy" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">Entered By<span style="display:none;">"Partial or full ID of the user that entered or submitted the consent"</span></label>
                            <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                                <input class="form-control" title="Entered By" id="enteredBy" name="enteredBy" type="text" maxlength="255" size="30" data-tooltip="<c:out value="${descriptors['enteredByField']}" />"/>
                            </div>
                        </div>
                        <div class="form-group">
                            <label for="patientTypes" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">Patient Types<span style="display:none;">"Choose whether you would like to filter by real patients only, test patients only, or both."</span></label>
                            <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                                <select class="form-control" id="patientTypes" name="patientTypes" data-tooltip="<c:out value="${descriptors['patientTypesField']}" />">
                                    <option value="3">ALL</option>
                                    <option value="1" selected>Real Patients</option>
                                    <option value="2">Test Patients</option>
                                </select>
                            </div>
                        </div>
                    </form>
                    <div class="form-group">
                        <div class="col-xs-6 col-sm-6 col-md-6 col-lg-6 text-right">
                            <button class="btn btn-primary" type="button" id="searchButton">Search</button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div><div aria-live="assertive" role="alert" id="reportTable_info"></div></div>
    <div id="results">
        <div class="panel panel-default" id="divReportPanel">
            <div class="panel-heading">
                <div class="panel-title">
                    <div class="pull-left">
                        <a href="#" title="Close Search Results" aria-label="Close Search Results" class="vap-panel-hide-show"><i class="fa fa-minus" aria-hidden="true" data-panel-body="myResultsPanel"></i></a> Search Results
                    </div>
                    <div class="pull-right">
                        <a href="#" data-toggle="modal" data-target="#confirmExportModal" data-method="exportToExcel" title="Export to Excel" class="pad-right-10"><i class="fa fa-download" aria-hidden="true"></i> Export to Excel</a>
                        <a href="#" data-toggle="modal" data-target="#confirmExportModal" data-method="exportToCsv" title="Export to CSV" class="pad-right-10"><i class="fa fa-download" aria-hidden="true"></i> Export to CSV</a>
                    </div>
                    <div class="clearfix"></div>
                </div>
            </div>   
            <div class="panel-body" id="myResultsPanel">
                <%@include file="patientLinkForm.jsp"%>    
                <form action="OptInOptOutReport.do_sec" method="POST" onsubmit="return doSubmit(this)" id="documentViewForm">
                    <input type="hidden" name="view" value="true"> 
                    <input type="hidden" name="documentUniqueId" value="" id="documentUniqueId">
                </form>
                <br/>
                <table id="reportTable" class="table table-striped" width="100%" cellspacing="0" role="presentation">
                    <thead>
                        <tr role="row">
                            <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['ssnColumn']}" />">SSN</span></th>
                            <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['lastNameColumn']}" />">Patient Last Name</span></th>
                            <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['firstNameColumn']}" />">Patient First Name</span></th>
                            <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['eventOccurredColumn']}" />">Time of Event (CT)</span></th>
                            <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['consentDirectiveDetailedReportPatientSignatureDateColumn']}" />">Patient Signature/<br />Patient Deceased Date</span></th>
                            <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['purposeOfUseColumn']}" />">Purpose of Use</span></th>
                            <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['consentTypeSansAllColumn']}" />">Consent Type</span></th>
                            <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['consentDirectiveDetailedReportInactivationReasonColumn']}" />">Inactivation Reason</span></th>
                            <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['enteredByManualOrSystemColumn']}" />">Entered By</span></th>
                            <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['consentDirectiveDetailedReportAuthenticatingFacilityColumn']}" />">Authenticating Facility</span></th>
                            <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['consentDirectiveDetailedReportAuthenticatingFacilityStationIdColumn']}" />">Authenticating Facility Station ID</span></th>
                            <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['visnForAuthenticatingFacilityColumn']}" />" data-tooltip-position="left">VISN</span></th>
                            <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['genericViewColumn']}" />" data-tooltip-position="left">View</span></th>
                        </tr>
                    </thead>
                </table>
            </div>
        </div>                   
    </div>
    <%-- modal to show the restricted organizations --%> 
    <div class="modal fade" id="restrictionsListModal" tabindex="-1" role="dialog" data-backdrop="static" aria-labelledby="restrictionsListModalLabel">
        <div class="vertical-alignment-helper">
            <div class="modal-dialog vertical-align-center" role="document">
                <div class="modal-content">
                    <div class="modal-header">
                        <h4 class="modal-title" id="restrictionsListModalLabel">Restriction Details</h4>
                    </div>
                    <div class="modal-body" id="restrictionsListModalBody"></div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
                    </div>
                </div>
            </div>
        </div>
    </div>   
</f:mainTemplate>