<%--
    Document   : Opt-in/Opt-out Summary Report
    Created By : David Vasquez / Robert Snelling
    Modified By: Asha Amritraj
--%>
<%@page import="gov.va.nvap.svc.facility.data.Facility"%>
<%@page import="java.util.*"%>
<%@page import="java.text.SimpleDateFormat"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<%@taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn" %>
<%@taglib tagdir="/WEB-INF/tags/cpp" prefix="cpp" %>
<%@taglib tagdir="/WEB-INF/tags/date" prefix="date" %>
<%@taglib tagdir="/WEB-INF/tags/formatting" prefix="f" %>

<%
    HashMap tips = (HashMap) session.getAttribute("descriptors");
    String facilityFilterTooltip = (String) tips.get("authenticatingFacilityField");
    Facility defaultUserFacility = (Facility) session.getAttribute("defaultUserFacility");
    String defaultUserFacilityName = defaultUserFacility == null ? "" : defaultUserFacility.getFacilityName();
    String defaultUserFacilityStation = defaultUserFacility == null ? "" : defaultUserFacility.getFacilityStation();
    pageContext.setAttribute("facilityFilterTooltip", facilityFilterTooltip);
    pageContext.setAttribute("defaultUserFacility", defaultUserFacility);
    pageContext.setAttribute("defaultUserFacilityName", defaultUserFacilityName);
    pageContext.setAttribute("defaultUserFacilityStation", defaultUserFacilityStation);
    
    Date today = new Date();
    SimpleDateFormat ft = new SimpleDateFormat ("MM/dd/yyyy");
    String maxDate = ft.format(today);
    
    pageContext.setAttribute("maxDate", maxDate);
%>

<f:mainTemplate headerText="Consent Directive Summary Report">
    <script language="JavaScript">
        $(document).ready(function () {
            /*$("#startDate").datepicker({
                maxDate: 0,
                dateFormat: 'mm/dd/yy',
                onClose: function (selectedDate) {
                    $("#endDate").datepicker("option", "minDate", selectedDate);
                    $(this).focus();
                }
            });

            $("#endDate").datepicker({
                maxDate: 0,
                dateFormat: 'mm/dd/yy',
                onClose: function (selectedDate) {
                    $("#startDate").datepicker("option", "maxDate", selectedDate);
                    $(this).focus();
                }
            });*/
            
            $('#startDate').datepicker({
                theme: 'vap',
                inputFormat: 'MM/dd/yyyy',
                outputFormat: 'MM/dd/yyyy',
                gainFocusOnConstruction: false,
                max: '<c:out value="${maxDate}" />',
                onUpdate: function(curValue) {
                    $('#endDate').datepicker('min', curValue);
                }
            });
            
            $('#endDate').datepicker({
                theme: 'vap',
                inputFormat: 'MM/dd/yyyy',
                outputFormat: 'MM/dd/yyyy',
                gainFocusOnConstruction: false,
                max: '<c:out value="${maxDate}" />',
                min: '<c:out value="${startDateDefault}" />',
                onUpdate: function(curValue) {
                    $('#startDate').datepicker('max', curValue);
                }
            });
            
            VAP.common.setProcessingForDataTable('reportTable', 'divReportPanel');

            VAP.common.reportTable = $('#reportTable').DataTable({
                deferLoading: 0,
                destroy: true,
                ajax: VAP.common.constructUrl("doSearch"),
                info: false,
                ordering: true,
                paging: false,
                processing: true,
                searching: false,
                serverSide: true,
                columnDefs: [
                    {className: "width-350 ", targets: [0]},
                    {className: "text-right", targets: [1,2,3,4,5,6]}
                ],
                "footerCallback": function ( row, data, start, end, display ) {
                    var api = this.api(), data;
    
                    // Update footers
                    $(api.column(1).footer() ).html(
                        api.column(1, {page:'current'}).data().sum()
                    );
            
                    $(api.column(2).footer() ).html(
                        api.column(2, {page:'current'}).data().sum()
                    );
            
                    $(api.column(3).footer() ).html(
                        api.column(3, {page:'current'}).data().sum()
                    );
            
                    $(api.column(4).footer() ).html(
                        api.column(4, {page:'current'}).data().sum()
                    );
            
                    $(api.column(5).footer() ).html(
                        api.column(5, {page:'current'}).data().sum()
                    );
            
                    $(api.column(6).footer() ).html(
                        api.column(6, {page:'current'}).data().sum()
                    );
                }
            });
            
            VAP.common.reportTable.on('draw', function () {
                VAP.common.addAriaToDataTable('reportTable', VAP.common.reportTable);
            });
            
            $('#searchButton').on('click', function () {
                $('#reportTable .dataTables_empty').html(''); //blank out the empty table message if there is one
                
                var startDate = $('#startDate').val();
                var endDate = $('#endDate').val();

                var errorMessage = VAP.common.validateStartAndEndDate(startDate, endDate);
                
                if (errorMessage != '')
                {
                    //we have an error so show the error, and then don't send the ajax request
                    $('#errorMessage').html(errorMessage);
                    $('#errorMessage').show();

                    return false;
                } else {
                    //no error, let's make the call to populate the report
                    $('#results').show();
                    VAP.common.reportTable.ajax.url(VAP.common.constructUrl('doSearch')).load();
                }
            });
            
            $('#startDate,#endDate').on('change', function () {
                //if either date changes, hide the error message if its not already hidden
                $('#errorMessage').hide();
            });
            
            $('#results').hide();
        });
        
        VAP.common.constructUrl = function(methodName) {
            var url = 'OptInOptOutSummaryReport.do_sec' +
                '?' + methodName + '=true' +
                '&startDate=' + $('#startDate').val() +
                '&endDate=' + $('#endDate').val() +
                '&actionType=' + $('#actionType').val() +
                '&stationNumbers=' + facilitiesDialog.getSelectedStationNumbers() +
                '&patientTypes=' + $('#patientTypes').val() +
                '&enteredBy=' + $('#enteredBy').val() +
                '&includeUnknownVisn=' + facilitiesDialog.getIncludeUnknownVisn() +
                '&aggregateAtFacilityLevel=' + facilitiesDialog.getAggregateAtFacilityLevel()+
                '&sortBy=' + $('#reportTable').dataTable().fnSettings().aaSorting[0][0] +
                '&sortOrder=' + $('#reportTable').dataTable().fnSettings().aaSorting[0][1];
            return url;
        };
    </script>

    <div class="row">
        <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12">
            <div class="panel panel-default">
                <div class="panel-heading">
                    <div class="panel-title">
                        <a href="#" title="Close Search Criteria" aria-label="Close Search Criteria" class="vap-panel-hide-show"><i class="fa fa-minus" aria-hidden="true" data-panel-body="consentDirectiveSummaryReportSearchPanel"></i></a> Search Criteria
                    </div>
                </div>    
                <div class="panel-body" id="consentDirectiveSummaryReportSearchPanel">
                    <div class="alert alert-info">
                        Fill in the fields below to narrow your search. All dates will be included if Start Date and End Date are left blank.
                    </div>
                    <div id="errorMessage" class="alert alert-warning" style="display: none;" role="alert"></div>
                    <form name="optInOptOutSummaryReportForm" id="optInOptOutSummaryReportForm" class="form-horizontal">
                        <input type="hidden" id="consentTypeName" name="consentTypeName" />

                        <div class="form-group">
                            <label for="startDate" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">Start Date</label>
                            <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3" data-tooltip="<c:out value="${descriptors['startDateEndDateField']}" />">
                                <input type="text" name="startDate" id="startDate" class="form-control" value="<c:out value="${startDateDefault}" />" />
                            </div>
                        </div>
                        <div class="form-group">
                            <label for="endDate" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">End Date</label>
                            <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3" data-tooltip="<c:out value="${descriptors['startDateEndDateField']}" />">
                                <input type="text" name="endDate" id="endDate" class="form-control" value="<c:out value="${endDateDefault}" />" />
                            </div>
                        </div>
                        <jsp:include page="reporting/common/facilitiesFilter.jsp">
                            <jsp:param name="defaultUserFacility" value="${defaultUserFacility}" />
                            <jsp:param name="defaultUserFacilityName" value="${defaultUserFacilityName}" />
                            <jsp:param name="defaultUserFacilityStation" value="${defaultUserFacilityStation}" />                                                                            
                            <jsp:param name="facilityFilterTooltip" value="${facilityFilterTooltip}" />
                        </jsp:include>
                        <div class="form-group">
                            <label for="enteredBy" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">Entered By</label>
                             <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3">
                                <input title="Entered By" id="enteredBy" name="enteredBy" type="text" maxlength="255" class="form-control" data-tooltip="<c:out value="${descriptors['enteredByField']}" />"/>
                             </div>
                        </div>
                        <div class="form-group">
                            <label for="patientTypes" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">Patient Types</label>
                            <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3">
                                <select id="patientTypes" name="patientTypes" data-tooltip="<c:out value="${descriptors['patientTypesField']}" />" class="form-control">
                                    <option value="3">ALL</option>
                                    <option value="1" selected>Real Patients</option>
                                    <option value="2">Test Patients</option>
                                </select>
                            </div>
                        </div>
                    </form>
                    <div class="form-group">
                        <div class="col-xs-7 col-sm-7 col-md-7 col-lg-7 text-right">
                            <input name="search" title="Search" class="btn btn-primary" type="submit" value="Search" id="searchButton"/>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div><div aria-live="assertive" role="alert" id="reportTable_info"></div></div>
    <div id="results">
        <div class="row">
            <div id="divReportContent" class="col-xs-12 col-sm-12 col-md-12 col-lg-12">
                <div class="panel panel-default" id="divReportPanel">
                    <div class="panel-heading">
                        <div class="panel-title">
                            <div class="pull-left">
                                <a href="#" title="Close Search Results" aria-label="Close Search Results" class="vap-panel-hide-show"><i class="fa fa-minus" aria-hidden="true" data-panel-body="consentDirectiveSummaryReportResultsPanel"></i></a> Search Results
                            </div>
                            <div class="pull-right">
                                <a href="#" class="directDownload" data-method="exportToExcel" title="Export to Excel"><i class="fa fa-download" aria-hidden="true"></i> Export to Excel</a>
                            </div>
                            <div class="clearfix"></div>
                        </div>
                    </div>    
                    <div class="panel-body" id="consentDirectiveSummaryReportResultsPanel">
                        <table id="reportTable" class="table table-striped" width="100%" cellspacing="0" role="presentation">
                            <thead>
                                <tr role="row">
                                    <th role="columnheader" class="text-center"><span id="authFacilityHeader" data-tooltip="<c:out value="${descriptors['authenticatingFacilityColumn']}" />">Authenticating Facility</span></th>
                                    <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['consentDirectiveSummaryAuthorizations']}" />">${organizationName} Authorizations</span></th>
                                    <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['consentDirectiveSummaryRevocations']}" />">${organizationName} Revocations</span></th>
                                    <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['consentDirectiveSummaryRestrictions']}" />">${organizationName} Restrictions</span></th>
                                    <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['consentDirectiveSummaryRestrictionRevocations']}" />">${organizationName} Restriction Revocations</span></th>
                                    <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['consentDirectiveSummarySSAAuthorizations']}" />">SSA Authorizations</span></th>
                                    <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['consentDirectiveSummarySSARevocations']}" />" data-tooltip-position="left" >SSA Revocations</span></th>
                                </tr>
                            </thead>
                            <tfoot>
                                <tr role="row">
                                    <td role="gridcell" class="bold text-left">Total:</td>
                                    <td role="gridcell" class="bold text-right"></td>
                                    <td role="gridcell" class="bold text-right"></td>
                                    <td role="gridcell" class="bold text-right"></td>
                                    <td role="gridcell" class="bold text-right"></td>
                                    <td role="gridcell" class="bold text-right"></td>
                                    <td role="gridcell" class="bold text-right"></td>
                                </tr>
                            </tfoot>
                        </table>
                    </div>
                </div>
            </div>
        </div>
    </div>
</f:mainTemplate>