<%--
    Document   : scheduledExports
    Created on : Sep 8, 2016, 12:08:31 PM
    Author     : Zachary Tubb
--%>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@taglib tagdir="/WEB-INF/tags/formatting" prefix="f" %>
<%@taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn" %>

<f:mainTemplate headerText="Scheduled Exports">
    <script language="JavaScript">
        $(document).ready(function(){
            VAP.common.setProcessingForDataTable('reportTable', 'divReportPanel');

            VAP.common.reportTable = $('#reportTable').DataTable( {
                destroy: true,
                searching: false,
                processing: true,
                serverSide: true,
                order: [[2, 'desc']],
                ajax: "ScheduledExports.do_sec?getUserExports=true",
                columnDefs: [
                    {orderable: false, targets: 4},
                    {className: "text-center vertical-align-center", targets: 4}
                ],
                lengthMenu: [ 10, 25, 50, 100, 250, 500 ],
                pageLength: 25
            });
            VAP.common.reportTable.on('draw', function () {
                VAP.common.addAriaToDataTable('reportTable', VAP.common.reportTable);
            });
            $('#refreshButton').on('click', function() {
                $('#reportTable .dataTables_empty').html(''); //blank out the empty table message if there is one
                $('#reportTable').DataTable().ajax.reload();
            });
            
            // DataTables overrides
            VAP.common.reportTable.on('draw', function () {
                VAP.common.addAriaToDataTable('reportTable', VAP.common.reportTable);
                VAP.common.addSrollingToDataTable('reportTable');
            });
        });
    </script>
    <div class="alert alert-info">
        Excel and CSV exports for reports will appear here for download once the export generation has been completed.
    </div>
    <div><div aria-live="assertive" role="alert" id="reportTable_info"></div></div>
    <div id="divReportContent" class="col-xs-12 col-sm-12 col-md-12 col-lg-12">
        <div class="panel panel-default" id="divReportPanel">
            <div class="panel-body">
                <button class="btn pull-right" id="refreshButton" title="Refresh">Refresh <span class="fa fa-refresh" aria-hidden="true"></span></button>
                <table id="reportTable" class="display table table-striped" width="100%" cellspacing="0" role="presentation">
                    <thead>
                        <tr role="row">
                            <th role="columnheader" class="text-center" style="min-width: 320px;"><span data-tooltip="<c:out value="${descriptors['scheduledExportsReportColumn']}" />">Report</span></th>
                            <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['scheduledExportsFormatColumn']}" />">Format</span></th>
                            <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['scheduledExportsDateColumn']}" />">Date Generated (CT)</span></th>
                            <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['scheduledExportsStatusColumn']}" />">Status</span></th>
                            <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['scheduledExportsDownloadColumn']}" />" data-tooltip-position="left">Download</span></th>
                        </tr>
                    </thead>
                </table>
            </div>
        </div>
    </div>
</f:mainTemplate>